# This script creates the backout package for a patch package
#
# directory format options.
#
#pragma ident	"@(#)postinstall	1.32	11/02/03 SMI"
#
# Copyright (c) 1995, 2011, Oracle and/or its affiliates. All rights reserved.
#

# Definitions for override safety mechanism
PATCH_OVERRIDE_LIB="${PKG_INSTALL_ROOT}/usr/lib/patch/patch_override_lib"

# Check if we messaging is ready. Returns 0 on success, 1 on failure
# On successful run it leaves MSG_FILENAME variable defined
# 
# Usage:
#
# check_patch_script_messaging
#
check_patch_script_messaging()
{
	TMP_DIRNAME="/var/run"
	MSG_FILENAME="${TMP_DIRNAME}/patchadd_msg_file_${SUNW_PATCHID}"

	if [ -w "${MSG_FILENAME}" ] ; then
		unset TMP_DIRNAME
		return 0
	else
		unset TMP_DIRNAME
		unset MSG_FILENAME
		return 1
	fi
}

# This function prepares a message to be printed to stdout towards the end
# of postpatch execution. If the message file is not ready, it at least tries
# immediate output to stdout which is currently know to work only in patch
# level scripts.
#
# Usage:
#
# print_patch_message "text_of_message_to_be_printed_out"
#
print_patch_message()
{
	if check_patch_script_messaging; then
		echo "$*" >> "${MSG_FILENAME}"
	else
		echo "$*"
	fi

	return 0
}

# script in a fucntion so that it can be overridden if needed - generic
postinstall_deflt()
{
	# Description:
	#       Set the TYPE parameter for the remote file
	#
	# Parameters:
	#       none
	#
	# Globals set:
	#	TYPE
	#

	set_TYPE_parameter () {
		if [ ${PATCH_UNDO_ARCHIVE:?????} = "/dev" ]; then
			# handle device specific stuff
			TYPE="removable"
		else
			TYPE="filesystem"
		fi
	}

	#
	# Description:
	#       Build the remote file that points to the backout data
	#
	# Parameters:
	#       $1:	the un/compressed undo archive
	#
	# Globals set:
	#	UNDO, STATE

	build_remote_file () {
		remote_path=$PKGSAV/$SUNW_PATCHID/remote
		set_TYPE_parameter
		STATE="active"

		if [ $1 = "undo" ]; then
			UNDO="undo"
		else
			UNDO="undo.Z"
		fi

		cat > $remote_path <<- EOF
	# Backout data stored remotely
	TYPE=$TYPE
	FIND_AT=$ARCHIVE_DIR/$UNDO
	STATE=$STATE
	EOF
	}

	SED="/usr/bin/sed"
	CP="/usr/bin/cp"
	RM="/usr/bin/rm -f"
	MV="/usr/bin/mv"
	EXPR="/usr/bin/expr"
	RMF="/usr/sbin/removef"
	XARGS="/usr/bin/xargs"
	NAWK="/usr/bin/nawk"
	POSTINSTALL_ERR_LOG="$PKG_INSTALL_ROOT/var/run/$SUNW_PATCHID.postinstall_log.$$"
	RET_STATUS=0

	PATH=/usr/sadm/bin:$PATH
	PATCH_COMMON_LIB="/usr/lib/patch/patch_common_lib"
	SAFEMODE_FAILED="Exiting! Patch deferred activation failed"

	# Set LC_ALL to avoid risk of undefined behavior
	LC_ALL=C
	export LC_ALL

	if [ "$SAFEMODE_INSTALL" = "true" ] ; then
		if [ ! -s "$PATCH_COMMON_LIB" ]; then
			puttext "$SAFEMODE_FAILED"
			exit 1
		fi
		. $PATCH_COMMON_LIB
		InitSafemode || {
			puttext $SAFEMODE_FAILED
			exit 1
		}
	fi

	if [ "$PKG_INSTALL_ROOT" = "/" ]; then
		PKG_INSTALL_ROOT=""
	fi

	if [ -n "$PATCH_BUILD_DIR" -a -d "$PATCH_BUILD_DIR" ]; then
		BUILD_DIR="$PATCH_BUILD_DIR/$SUNW_PATCHID.$PKGINST"
	else
		BUILD_DIR="$PKG_INSTALL_ROOT/var/tmp/$SUNW_PATCHID.$PKGINST"
	fi

	if [ ! -n "$PATCH_UNDO_ARCHIVE" ]; then
		PATCH_UNDO_ARCHIVE="none"
	fi

	FILE_DIR=$BUILD_DIR/files
	RELOC_DIR=$FILE_DIR/reloc
	ROOT_DIR=$FILE_DIR/root
	BO_Deletes=$FILE_DIR/deletes
	THIS_DIR=`dirname $0`
	PROTO_FILE=$BUILD_DIR/prototype
	TEMP_REMOTE=$PKGSAV/$SUNW_PATCHID/temp

	# If patch includes pkg_* scripts, deliver them into the pspool area
	#
	PKGDB="/var/sadm/pkg/$PKGINST"
	PSPOOL_PKG="$PKGDB/save/pspool/$PKGINST"


	for script in $SCRIPTS_DIR/*; do
		srcscript=`basename $script`
		targscript=`echo $srcscript | $NAWK '
			/^pkg_/ {
				print "pspool";
				next;
			}
			{ print "dont_use" } '`
		if [ "$targscript" = "dont_use" ]; then
			continue
		fi
		if [ "$targscript" = "pspool" ]; then
			# If the target script is a pspool script, then we need
			# to do the following:
			#	1) If the script is delivered for the first time
			#	   then add it to the deletes file of the undo
			#	   package.
			#	2) Else backup the script in the undo package,
			#	   replace the script and update the undo packag
			#	   prototype file.
			script=`echo $srcscript | $SED 's/pkg_//'`
			if [ -d "$PKG_INSTALL_ROOT$PSPOOL_PKG/install" ] ; then
				# We are delivering script into pspool area
				[ "$PATCH_NO_UNDO" != "true" ] && {
					if [ -f "$PKG_INSTALL_ROOT$PSPOOL_PKG/install/$script" ]; then
						$MV $PKG_INSTALL_ROOT$PSPOOL_PKG/install/$script $FILE_DIR/$srcscript
						echo "i $srcscript=$FILE_DIR/$srcscript" >> $PROTO_FILE
					else
						echo "$PSPOOL_PKG/install/$script" >> $BO_Deletes
					fi
				}
				$CP $SCRIPTS_DIR/$srcscript $PKG_INSTALL_ROOT$PSPOOL_PKG/install/$script
			fi
			if [ -d "$PKG_INSTALL_ROOT$PKGDB/install" ] ; then
				# If patch delivers pkg_* scripts which is pkgrm relevant
				# deliver them also into /var/sadm/install/pkg/<pkg>/install
				scripttype=`echo $srcscript | $NAWK '
					/^pkg_preremove$|^pkg_postremove$|^pkg_r\./ {
						print "pkgremove";
						next;
					}
					{ print "dont_use" } '`

				if [ "$scripttype" = "pkgremove" ] ; then
					[ "$PATCH_NO_UNDO" != "true" ] && {
					if [ -f "$PKG_INSTALL_ROOT$PKGDB/install/$script" ]; then
						# Due to previously existing bug scripts could be different
						# in /var/sadm/pkg/<pkg>/install and
						# /var/sadm/pkg/<pkg>/save/pspool/<pkg>/install
						# After backout we will go back to the exactly same state
						# Because of that we create pkgrm_* file in backout package
						$MV $PKG_INSTALL_ROOT$PKGDB/install/$script $FILE_DIR/pkgrm_$script
						echo "i pkgrm_$script=$FILE_DIR/pkgrm_$script" >> $PROTO_FILE
					else
						echo "$PKGDB/install/$script" >> $BO_Deletes
					fi
					}
					$CP $SCRIPTS_DIR/$srcscript $PKG_INSTALL_ROOT$PKGDB/install/$script
				fi
			fi
		fi
	done
	
	#
	# At this point we either have a deletes file or we don't. If we do,
	# we create a prototype entry.
	#
	if [ -f $BO_Deletes ]; then
		echo "i deletes=$BO_Deletes" >> $BUILD_DIR/prototype
	fi

	if [ -f $BUILD_DIR/pkginfo ] ; then
		/usr/bin/grep "^SUNW_PATCH_SAFE_MODE=" $SCRIPTS_DIR/../pkginfo >> \
		    $BUILD_DIR/pkginfo
	fi 

	#
	# Now delete everything in the deletes list after transferring
	# the file to the backout package and the entry to the prototype
	# file. Remember that the pkgmap will get the CLIENT_BASEDIR path
	# but we have to actually get at it using the BASEDIR path. Also
	# remember that removef will import our PKG_INSTALL_ROOT
	#
	# If this is a safemode patch package and it has a deletes file in it
	# then handle the deletion of an object for safemode patching.
	#
	Our_Deletes=$THIS_DIR/deletes
	if [ -f $Our_Deletes ]; then
		PSPOOL_DIR="/var/sadm/pkg/$PKGINST/save/pspool/$PKGINST/install"
		UNREGISTER_LIST=/var/run/.$$.unregister.paths.$$
		UNREGISTER_BATCH=/var/run/.$$.unregister.batch.$$
		$RM $UNREGISTER_LIST

		cd $BASEDIR
		cat $Our_Deletes | while read path; do
			# If this patch is deleting any pspool script, then the
			# deleted file would have any entry for the script
			# relative to the PKG_INSTALL_ROOT. We have to parse it
			# and process it as follows.
			#	1) build the complete path.
			#	2) move the file to undo package.
			#	3) Add it to the prototype file of undo package.
			Dir=`/usr/bin/dirname "$path"`
			if [ "$Dir" = "$PSPOOL_DIR" ]; then
				path="${PKG_INSTALL_ROOT:-/}$path"
				if [ -f "$path" ]; then
					filename=`/usr/bin/basename "$path"`
					spoolname="pkg_$filename"
					spoolfile="$FILE_DIR/$spoolname"
					mv -f "$path" "$spoolfile"
					echo "i $spoolname=$spoolfile" >> $BUILD_DIR/prototype
				fi
				continue;
			fi
			Reg_File=0
			# Checking whether path is absolute or relative
			if echo "$path" | grep '^/' 2>&1 1>/dev/null ; then
				# It's an absolute path
				Client_Path=$path
				Build_Path="$ROOT_DIR$path"
				Proto_Path=$PKG_INSTALL_ROOT$path
			else
				Client_Path="$CLIENT_BASEDIR/$path"
				Build_Path="$RELOC_DIR/$path"
				Proto_Path=$BASEDIR/$path
			fi

			# If BASEDIR/CLIENTBASEDIR = "/", then the previous prepends
			# an extra / i.e. //. The sed command later can't find a
			# Proto_Path with // and therefore will not substitute the
			# correct build_Path resulting in the backout pkg not being
			# created.

			if [ "$CLIENT_BASEDIR" = "/" ]; then
				Client_Path=`echo "$Client_Path" | $SED 's|^\/\/|\/|'`
				Proto_Path=`echo "$Proto_Path" | $SED 's|^\/\/|\/|'`
			fi
				
			# Note: If the file isn't really there, pkgproto
			# doesn't write anything but displays an error
			# so check for the file before processing.

			if [ -f "$Proto_Path" ]; then
				LINE=`pkgproto "$Proto_Path=$path"`
			else
				continue
			fi

			ftype=`echo "$LINE" | $NAWK '{ print $1 }'`
			if [ "$ftype" = "f" ]; then
				Reg_File=1
			fi

			if [ $Reg_File = 1 ]; then
				# Add source file to the prototype entry
                                # nawk is used here instead of sed because sed
                                # allows only substitution of RE (regular 
                                # expressions) and we can't be sure that $dst
                                # will not contain special characters 

				LINE=`echo "$LINE" | $NAWK -v \
				    Proto_Path="$Proto_Path" -v \
				    Build_Path="$Build_Path" -v path="$path" '
        				{ 
                    			ind = index($3,Proto_Path);
                    			if (ind == 0) {
                        			print $0;
                        			next;
                    			}
                    			len = length(Proto_Path);
                    			if (Proto_Path == path) {
                        			ind2 = index(substr($3,ind+len),Proto_Path);
                        			if (ind2 == 0) {
                                			print $0;
                                			next;
                        			}
                        			ind = ind + len + ind2 - 1;     
                    			}
                    			rec = substr($3,1,ind-1) Build_Path substr($3,ind+len);
					$3 = rec;
					print $0;
                  			}
				'`
				DirName=`dirname "$Build_Path"`
				# make room in the build tree
				mkdir -p "$DirName"
				$CP -p "$Proto_Path" "$Build_Path"
			fi

			# Insert it into the prototype file
			echo "$LINE" 1>>$PROTO_FILE 2>/dev/null
			echo "$Client_Path" >> $UNREGISTER_LIST
		done

		if [ -s "$UNREGISTER_LIST" ]; then
			if [ "$SAFEMODE_INSTALL" = "true" ]; then
				# We need to group the deletes entries for
				# performance reasons. Only 100 entries are
				# taken in a single batch, since we don't want
				# to exceed the number of arguments passed
				# during removef program invocation, and 100
				#  seems to a good tradeoff.

				batch_start_line=1
				batch_end_line=100

				while true ; do
					/usr/bin/sed -n "$batch_start_line,$batch_end_line p" $UNREGISTER_LIST > $UNREGISTER_BATCH
					[ -s $UNREGISTER_BATCH ] || break

					# Handle deletion of an object for
					# safemode patching
					# We do not use xargs here because xargs
					# can't handle shell function calls
	
					HandleSafemodeDeleteObject $PKGINST "`/usr/bin/tr '\n' ' ' < $UNREGISTER_BATCH`"

					batch_start_line=`$EXPR $batch_start_line + 100`
					batch_end_line=`$EXPR $batch_end_line + 100`
				done
			else
				# Remove the file only if it's OK'd by removef
				# We don't need to group deletes entries here
				# because xargs does it for us

				$XARGS $RMF $PKGINST < $UNREGISTER_LIST | \
				while read path; do
					$RM "$path"
				done
			fi
			$RMF -f $PKGINST
		fi
		$RM $UNREGISTER_LIST $UNREGISTER_BATCH

		$RM $Our_Deletes
	fi

	#
	# Unless specifically denied, make the backout package.
	#
	if [ "$PATCH_NO_UNDO" != "true" ]; then
		cd $BUILD_DIR	# We have to build from here.

		if [ "$PATCH_UNDO_ARCHIVE" != "none" ]; then
			STAGE_DIR="$PATCH_UNDO_ARCHIVE"
			ARCHIVE_DIR="$PATCH_UNDO_ARCHIVE/$SUNW_PATCHID/$PKGINST"
			mkdir -p $ARCHIVE_DIR
			mkdir -p $PKGSAV/$SUNW_PATCHID
		else
			if [ -d $PKGSAV/$SUNW_PATCHID ]; then
				rm -r $PKGSAV/$SUNW_PATCHID
			fi
			STAGE_DIR=$PKGSAV
			ARCHIVE_DIR=$PKGSAV/$SUNW_PATCHID
			mkdir $ARCHIVE_DIR
		fi

		ERR_LOG_DIR=`dirname $POSTINSTALL_ERR_LOG`
		if [ ! -d $ERR_LOG_DIR ]; then
			mkdir -p $ERR_LOG_DIR
		fi

		/usr/bin/pkgmk -o -d $STAGE_DIR 1>$POSTINSTALL_ERR_LOG 2>&1
		retcode=$?
		if [ "$retcode" != 0 ]; then
			echo "pkgmk(1) failed with error code $retcode" >> $POSTINSTALL_ERR_LOG
			echo "The $PKGINST backout package will not get created" >> $POSTINSTALL_ERR_LOG
			RET_STATUS=1
		else
			# Save current mask value using Bourne shell umask
			MASK=`umask`
			# undo package should be readable only for root
			umask 077
			/usr/bin/pkgtrans -s $STAGE_DIR $ARCHIVE_DIR/undo $PKG 1>>$POSTINSTALL_ERR_LOG 2>&1
			retcode=$?
			# set umask back to original value
			umask $MASK
			if [ "$retcode" != 0 ]; then
				echo "pkgtrans(1) failed with error code $retcode" >> $POSTINSTALL_ERR_LOG
				echo "The $PKGINST backout package will not get created" >> $POSTINSTALL_ERR_LOG
				RET_STATUS=1
			else
				compress $ARCHIVE_DIR/undo
				retcode=$?
				if [ "$retcode" != 0 ]; then
					echo "compress(1) returned error code $retcode"
					echo "The $PKGINST backout package will not be compressed."
					echo "Continuing to process backout package."
				fi
				if [ "$PATCH_UNDO_ARCHIVE" != "none" ]; then
					if [ $retcode != 0 ]; then
						build_remote_file "undo"
					else
						build_remote_file "undo.Z"
					fi
				fi
			fi
		fi

		$RM -r $STAGE_DIR/$PKG

		cd ..
		$RM -r $BUILD_DIR
	fi

	# remove the scripts that are left behind
	install_scripts=`dirname $0`
	$RM $install_scripts/checkinstall $install_scripts/patch_* \
	    $install_scripts/pkg_* $install_scripts/u.* $install_scripts/i.*

	#
	# Since this apparently worked, we'll mark as obsoleted the prior
	# versions of this patch - installpatch deals with explicit obsoletions.
	#
	cd ${PKG_INSTALL_ROOT:-/}
	cd var/sadm/pkg

	active_base=`echo $SUNW_PATCHID | $NAWK '
		{ print substr($0, 1, match($0, "-")-1) } '`

	List=`ls -d $PKGINST/save/${active_base}* 2>/dev/null`
	if [ $? -ne 0 ]; then
		List=""
	fi

	for savedir in $List; do
	        patch=`basename $savedir` 
	        if [ $patch = $SUNW_PATCHID ]; then
			break
		fi

	        # If we get here then the previous patch gets deleted
		if [ -f $savedir/undo ]; then
			$MV $savedir/undo $savedir/obsolete
			echo $SUNW_PATCHID >> $savedir/obsoleted_by
		elif [ -f $savedir/undo.Z ]; then
			$MV $savedir/undo.Z $savedir/obsolete.Z
			echo $SUNW_PATCHID >> $savedir/obsoleted_by
	        elif  [ -f $savedir/remote ]; then
	                `grep . $PKGSAV/$patch/remote | sed 's|STATE=.*|STATE=obsolete|' > $TEMP_REMOTE` 
	                $RM $PKGSAV/$patch/remote 
	                $MV $TEMP_REMOTE $PKGSAV/$patch/remote  
	                $RM $TEMP_REMOTE 
	                echo $SUNW_PATCHID >> $savedir/obsoleted_by
		elif  [ -f $savedir/obsolete -o -f $savedir/obsolete.Z ]; then
			echo $SUNW_PATCHID >> $savedir/obsoleted_by
		fi
	done

	if [ "$RET_STATUS" != 0 ]; then
		cat $POSTINSTALL_ERR_LOG
		echo "Execution of postinstall encountered problems"
		echo "postinstall exited with 1"
		$RM $POSTINSTALL_ERR_LOG
		exit $RET_STATUS
	else
		$RM $POSTINSTALL_ERR_LOG
	fi
}

# script in a fucntion so that it can be overridden if needed - particular
postinstall_merge()
{
	# If additional operations are required for this package, place
	# those package-specific commands here.

	#XXXSpecial_CommandsXXX#
#
# Copyright (c) 1996, 2014, Oracle and/or its affiliates. All rights reserved.
#
#pragma ident	"@(#)postinstall.SUNWdtdmr.tmpl	1.9	14/03/17 SMI"
#

if [ "$UPDATE" != yes ]; then
	# On initial install, do nothing.
	return 0
fi

upgrade_profile=${PKG_INSTALL_ROOT}/var/svc/profile/upgrade

# Remove inetd automatical convert manifests
rm -f ${PKG_INSTALL_ROOT}/var/svc/manifest/network/rpc/100083_1-rpc_tcp.xml
rm -f ${PKG_INSTALL_ROOT}/var/svc/manifest/network/rpc/100068_2-5-rpc_udp.xml
rm -f ${PKG_INSTALL_ROOT}/var/svc/manifest/network/dtspc-tcp6.xml

create_tmp_object() {
	mktemp_opts="";

	if [ "$1" = "-d" ] ; then
		mktemp_opts="-d";
		shift;
	fi

	tmp_object_path=${1:-/var/run};
	tmp_object_template=${2:-tmp.XXXXXX};

	#pragma PRC test_FIO43_C_CERT ignore-next-line
	for tmp_dir in ${tmp_object_path} /var/run /tmp ; do
		if [ -d ${tmp_dir} -a -w ${tmp_dir} ] ; then
			tmp_object_path=${tmp_dir};
			break;
		fi
	done

	( umask u=rwx,g=,o= ;
	  unset TMPDIR;
	  mktemp ${mktemp_opts} -t -p ${tmp_object_path} ${tmp_object_template};
	)

	return $?;
}

detect_and_set_enabled_daemons_from_inetd ()
{
        secure_tmp_dir=`create_tmp_object -d`

        dest=${PKG_INSTALL_ROOT}/etc/inet/inetd.conf
        tdest=`create_tmp_object "${secure_tmp_dir}" "inetd.conf.XXXXX"`
        upgrade_profile=${PKG_INSTALL_ROOT}/var/svc/profile/upgrade
        upgrade=`create_tmp_object "${secure_tmp_dir}" "upgrade.XXXXX"`

        #
        # The entire inetd.conf file will be scanned
        # and appropriate lines upgraded as they are read.
        #
        nawk -v uf=$upgrade '
                /^[^#.]*rpc\.ttdbserver/ {
                        # rpc.ttdbserverd == network/rpc/cde-ttdbserver
			# Remove inet daemon ttdbserverd from S8 S9 S10 FCS
			# and enable new smf service if possible
                        print "svcprop -q svc:/network/rpc-100083_1/rpc_tcp:default" >> uf;
                        print "[ \$? -ne 0 ] && svcadm enable svc:/network/rpc/cde-ttdbserver:tcp" >> uf;
                        next;
                }
                /^( |\t)*100068(\/2-5|\/2-4)( |\t)+[^#.]*(\/usr\/dt\/bin\/rpc\.cmsd|\/usr\/openwin\/bin\/rpc\.cmsd)/ {
                        # rpc.cmsd == network/rpc/cde-calendar-manager
			# Remove inet daemon rpc.cmsd from S8 S9 S10 FCS
			# and enable new smf service if possible
                        print "svcprop -q svc:/network/rpc-100068_2-5/rpc_udp:default" >> uf;
                        print "[ \$? -ne 0 ] && svcadm enable svc:/network/rpc/cde-calendar-manager:default" >> uf;
                        next;
                }
                /^[^#.]*dtspc/ {
                        # dtspc == network/cde-spc
			# Remove inet daemon dtspc from S8 S9 S10 FCS
			# and enable new smf service if possible
                        print "svcprop -q svc:/network/dtspc/tcp6:default" >> uf;
                        print "[ \$? -ne 0 ] && svcadm enable svc:/network/cde-spc:default" >> uf;
                        next;
                }
                /^#.*(ttdbserver|rpc\.cmsd|calendar|ToolTalk|dtspc)/ {
			# Remove some CDE services related comments
			next;
		}
                {
                        print $0
                }
                ' $dest > $tdest

        if [ $? -eq 0 ]; then
                cp $tdest $dest
                cat $upgrade >> $upgrade_profile
        fi

        rm -f "$tdest" "$upgrade"
	rmdir "$secure_tmp_dir"
}

detect_and_set_enabled_daemons_from_inetd

cat >> $upgrade_profile <<_EOF

cde_detect()
{
        # \$1 and \$2 must an instance of the FMRI
	if enabled=\`svcprop -c -p general/enabled \$1 2>/dev/null\` ; then
		svccfg delete -f \$1
                [ "\$enabled" = "true" ] && svcadm enable \$2
                [ "\$enabled" = "false" ] && svcadm disable \$2
        fi
}

cde_detect svc:/network/dtspc/tcp6:default \
	svc:/network/cde-spc:default

cde_detect svc:/network/rpc-100083_1/rpc_tcp:default \
	svc:/network/rpc/cde-ttdbserver:tcp

cde_detect svc:/network/rpc-100068_2-5/rpc_udp:default \
	svc:/network/rpc/cde-calendar-manager:default
cde_detect svc:/network/rpc/cde-calendar-manager:udp \
	svc:/network/rpc/cde-calendar-manager:default

_EOF

return 0
}

# load the override lib if it exists
if [ -f "${PATCH_OVERRIDE_LIB}" -a -r "${PATCH_OVERRIDE_LIB}" ] ; then
   . "${PATCH_OVERRIDE_LIB}"
fi

# execute the script functions
postinstall_deflt "$@"
postinstall_merge "$@"

exit 0
